unit QTTestU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    BtnFuncPointerParam: TButton;
    BtnPascalFuncParams: TButton;
    BtnCFuncParams: TButton;
    BtnProcNoParams: TButton;
    BtnPascalProcParams: TButton;
    BtnCProcParams: TButton;
    BtnProcPointerParam: TButton;
    BtnConstVarParams: TButton;
    BtnOpenArrayParam: TButton;
    procedure BtnProcNoParamsClick(Sender: TObject);
    procedure BtnPascalProcParamsClick(Sender: TObject);
    procedure BtnCProcParamsClick(Sender: TObject);
    procedure BtnProcPointerParamClick(Sender: TObject);
    procedure BtnConstVarParamsClick(Sender: TObject);
    procedure BtnOpenArrayParamClick(Sender: TObject);
    procedure BtnPascalFuncParamsClick(Sender: TObject);
    procedure BtnCFuncParamsClick(Sender: TObject);
    procedure BtnFuncPointerParamClick(Sender: TObject);
  end;

  TNumbers = array[11..15] of Smallint;

var
  Form1: TForm1;
  ProcAddress: Pointer;
  DllHandle: THandle;
  Param1, Param2, ReturnValue: Longint;
  MsgBuffer, MsgBuffer16: PChar;
  Msg: PChar = '32-bit call';
  OldNum: Smallint;
  NumPtr, NumPtr16: ^Smallint;
  StrPtr, StrPtr16: PShortString;
  Str: ShortString = 'Hello from 32-bit';
  Numbers: TNumbers = (1, 2, 3, 4, 5);
  NumOfNumbers: Word;
  NumbersPtr, NumbersPtr16: ^TNumbers;
  ReturnedMsg: PChar;

implementation

uses
  QTThunkU;

{$R *.DFM}

{$StackFrames On}
procedure TForm1.BtnProcNoParamsClick(Sender: TObject);
var
  EatStackSpace: String[$3C];
begin
  // Ensure buffer isn't optimised away
  EatStackSpace := '';
  // Try and load 16-bit DLL
  DLLHandle := LoadLib16('DLL16Bit.DLL');
  ProcAddress := GetProcAddress16(DLLHandle, 'NoParameters');
  if Assigned(ProcAddress) then
  asm
    //Load routine address into EDX
    mov   edx, ProcAddress
    //Call routine
    call  QT_Thunk
  end;
  //Now release 16-bit DLL
  FreeLibrary16(DLLHandle);
end;

procedure TForm1.BtnPascalProcParamsClick(Sender: TObject);
var
  EatStackSpace: String[$3C];
begin
  // Ensure buffer isn't optimised away
  EatStackSpace := '';
  // Try and load 16-bit DLL
  DLLHandle := LoadLib16('DLL16Bit.DLL');
  ProcAddress := GetAddress16(DLLHandle, 'Proc2ParamsPascal');
  if Assigned(ProcAddress) then
  begin
    Param1 := 5;
    Param2 := 20;
    asm
      push  Param1
      push  Param2
      mov   edx, ProcAddress
      call  QT_Thunk
    end;
  end;
  //Now release 16-bit DLL
  FreeLibrary16(DLLHandle);
end;

procedure TForm1.BtnCProcParamsClick(Sender: TObject);
var
  EatStackSpace: String[$3C];
begin
  // Ensure buffer isn't optimised away
  EatStackSpace := '';
  // Try and load 16-bit DLL
  DLLHandle := LoadLib16('DLL16Bit.DLL');
  ProcAddress := GetAddress16(DLLHandle, 'Proc2ParamsC');
  if Assigned(ProcAddress) then
  begin
    Param1 := 5;
    Param2 := 20;
    asm
      push  Param2 //Note second parameter is pushed first
      push  Param1
      mov   edx, ProcAddress
      call  QT_Thunk
      //Increment the stack ptr by size of the 2 Longint parameters
      add   esp, 4 * 2
    end;
  end;
  //Now release 16-bit DLL
  FreeLibrary16(DLLHandle);
end;

procedure TForm1.BtnProcPointerParamClick(Sender: TObject);
var
  EatStackSpace: String[$3C];
begin
  // Ensure buffer isn't optimised away
  EatStackSpace := '';
  // Try and load 16-bit DLL
  DLLHandle := LoadLib16('DLL16Bit.DLL');
  ProcAddress := GetProcAddress16(DLLHandle, 'ProcPointerParam');
  if Assigned(ProcAddress) then
  begin
    //Get and fill 16-bit memory with source string
    MsgBuffer16 := GlobalAllocPointer16(GPTR, 255, Pointer(MsgBuffer),
      Msg^, StrLen(Msg));
    asm
      push  MsgBuffer16
      mov   edx, ProcAddress
      call  QT_Thunk
    end;
    GlobalFreePtr16(MsgBuffer16);
  end;
  //Now release 16-bit DLL
  FreeLibrary16(DLLHandle);
end;

procedure TForm1.BtnConstVarParamsClick(Sender: TObject);
var
  EatStackSpace: String[$3C];
begin
  // Ensure buffer isn't optimised away
  EatStackSpace := '';
  // Try and load 16-bit DLL
  DLLHandle := LoadLib16('DLL16Bit.DLL');
  ProcAddress := GetProcAddress16(DLLHandle, 'ProcVarConstParams');
  if Assigned(ProcAddress) then
  begin
    OldNum := 0;
    //Get and fill 16-bit buffers with source data
    NumPtr16 := GlobalAllocPointer16(GPTR, SizeOf(Smallint),
      Pointer(NumPtr), OldNum, SizeOf(Smallint));
    StrPtr16 := GlobalAllocPointer16(GPTR, SizeOf(ShortString),
      Pointer(StrPtr), Str, Succ(Length(Str)));
    asm
      push  NumPtr16
      push  StrPtr16
      mov   edx, ProcAddress
      call  QT_Thunk
    end;
    ShowMessage(Format('Original var param = %d, new var param = %d',
      [OldNum, NumPtr^]));
    GlobalFreePtr16(NumPtr16);
    GlobalFreePtr16(StrPtr16);
  end;
  //Now release 16-bit DLL
  FreeLibrary16(DLLHandle);
end;

procedure TForm1.BtnOpenArrayParamClick(Sender: TObject);
var
  EatStackSpace: String[$3C];
begin
  // Ensure buffer isn't optimised away
  EatStackSpace := '';
  // Try and load 16-bit DLL
  DLLHandle := LoadLib16('DLL16Bit.DLL');
  ProcAddress := GetProcAddress16(DLLHandle, 'ProcOpenArrayParam');
  if Assigned(ProcAddress) then
  begin
    //Get and fill 16-bit buffer with source data
    NumbersPtr16 := GlobalAllocPointer16(GPTR, SizeOf(TNumbers),
      Pointer(NumbersPtr), Numbers, SizeOf(TNumbers));
    NumOfNumbers := High(TNumbers) - Low(TNumbers);
    asm
      push  NumbersPtr16
      push  NumOfNumbers
      mov   edx, ProcAddress
      call  QT_Thunk
    end;
    GlobalFreePtr16(NumbersPtr16);
  end;
  //Now release 16-bit DLL
  FreeLibrary16(DLLHandle);
end;

procedure TForm1.BtnPascalFuncParamsClick(Sender: TObject);
var
  EatStackSpace: String[$3C];
begin
  // Ensure buffer isn't optimised away
  EatStackSpace := '';
  // Try and load 16-bit DLL
  DLLHandle := LoadLib16('DLL16Bit.DLL');
  ProcAddress := GetAddress16(DLLHandle, 'Func2ParamsPascal');
  if Assigned(ProcAddress) then
  begin
    Param1 := 5;
    Param2 := 20;
    asm
      push  Param1
      push  Param2
      mov   edx, ProcAddress
      call  QT_Thunk
      mov   ReturnValue.Word.2, dx
      mov   ReturnValue.Word.0, ax
    end;
    ShowMessage(Format('Sum of parameters = %d', [ReturnValue]));
  end;
  //Now release 16-bit DLL
  FreeLibrary16(DLLHandle);
end;

procedure TForm1.BtnCFuncParamsClick(Sender: TObject);
var
  EatStackSpace: String[$3C];
begin
  // Ensure buffer isn't optimised away
  EatStackSpace := '';
  // Try and load 16-bit DLL
  DLLHandle := LoadLib16('DLL16Bit.DLL');
  ProcAddress := GetAddress16(DLLHandle, 'Func2ParamsC');
  if Assigned(ProcAddress) then
  begin
    Param1 := 5;
    Param2 := 20;
    asm
      push  Param2
      push  Param1
      mov   edx, ProcAddress
      call  QT_Thunk
      //Increment the stack ptr by size of the 2 Longint parameters
      add   esp, 4 * 2
      mov   ReturnValue.Word.2, dx
      mov   ReturnValue.Word.0, ax
    end;
    ShowMessage(Format('Sum of parameters = %d', [ReturnValue]));
  end;
  //Now release 16-bit DLL
  FreeLibrary16(DLLHandle);
end;

procedure TForm1.BtnFuncPointerParamClick(Sender: TObject);
var
  EatStackSpace: String[$3C];
begin
  // Ensure buffer isn't optimised away
  EatStackSpace := '';
  // Try and load 16-bit DLL
  DLLHandle := LoadLib16('DLL16Bit.DLL');
  ProcAddress := GetProcAddress16(DLLHandle, 'FuncPointerParam');
  if Assigned(ProcAddress) then
  begin
    //Get and fill 16-bit buffer with source data
    MsgBuffer16 := GlobalAllocPointer16(GPTR, 255,
      Pointer(MsgBuffer), Msg^, StrLen(Msg));
    asm
      push  MsgBuffer16
      mov   edx, ProcAddress
      call  QT_Thunk
      mov   ReturnedMsg.Word.0, ax
      mov   ReturnedMsg.Word.2, dx
    end;
    ShowMessage(Format('Msg received from 16-bit: %s',
      [PChar(Ptr16To32Fix(ReturnedMsg))]));
    Ptr16To32Unfix(ReturnedMsg);
    GlobalFreePtr16(MsgBuffer16);
  end;
  //Now release 16-bit DLL
  FreeLibrary16(DLLHandle);
end;

end.
