unit RichEdtU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Buttons;

type
  TForm1 = class(TForm)
    reSource: TRichEdit;
    reDest: TRichEdit;
    btnFont: TSpeedButton;
    dlgFont: TFontDialog;
    btnCopy: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure btnFontClick(Sender: TObject);
    procedure btnCopyClick(Sender: TObject);
    procedure AlternateSave(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  reSource.SelStart := 10;
  reSource.SelLength := 5;
  reSource.SelAttributes.Color := clMaroon;
  reSource.SelAttributes.Size := 24
end;

procedure TForm1.btnFontClick(Sender: TObject);
begin
  dlgFont.Font.Assign(reSource.SelAttributes);
  if dlgFont.Execute then
    reSource.SelAttributes.Assign(dlgFont.Font)
end;

procedure TForm1.btnCopyClick(Sender: TObject);
var
  stmStorage: TMemoryStream;
begin
  stmStorage := TMemoryStream.Create;
  try
    reSource.Lines.SaveToStream(stmStorage);
    stmStorage.Position := 0;
    reDest.Lines.LoadFromStream(stmStorage)
  finally
    stmStorage.Free
  end
end;

procedure TForm1.AlternateSave(Sender: TObject);
var
  PathName, FileName: array[0..Max_Path] of Char;
begin
  Win32Check(Bool(GetTempPath(SizeOf(PathName), PathName)));
  Win32Check(Bool(GetTempFileName(PathName, '~XX', 0, FileName)));
  try
    reSource.Lines.SaveToFile(FileName);
    reDest.Lines.LoadFromFile(FileName)
  finally
    DeleteFile(FileName)
  end
end;

end.
